function [sys,type,reset] = DelSig_sys(x,u)

% 3 state variables: two integrator outputs and the input to the quantizer 

%Define constants:
%Modulator constants
a = [0.0440 0.2881 0.7997];
b = [0.0440 0.2881 0.7997 1.0000];
c = [1 1 1];
g = 0;
T = 1;
constant_in = 0.8; % the contsant input value

%Type specifies the kind of continuous dynamics in the system.
type = 'linear';

% using 'q' from the comparator FSM to determine the comparator output
switch u
    case 1, % 0 to +2
        output_sign = 1;
    case 2, % 0 to -2
        output_sign = -1;
    case 3 % > +2
        output_sign = 1;
    case 4 % < -2
        output_sign = -1;
    otherwise
        output_sign = 0;
end

rp_temp1 = T*(b(1)*constant_in - a(1)*output_sign);
rp_temp2 = T*(b(2)*constant_in - a(2)*output_sign);
rp_temp3 = T*(b(3)*constant_in - a(3)*output_sign);
rp_temp4 = (c(3)*b(3) + b(4))*constant_in - c(3)*a(3)*output_sign;

% System matrices
sys.A = [1 0 0; T*c(1) 1 0; 0 T*c(2) 1];
sys.b = [rp_temp1 ; rp_temp2 ; rp_temp3];

return
