function box = grow_polytope(CE,dE,CI,dI,tmp)

%This function will 'grow' a polytope that has a dimension less than n. 
%The 'sizetol' parameter that is specified by the user in the parameter m-file
%is used as the size to grow the polytope.  If this parameter is not specified,
%then the default of 1e-4 is used.

global GLOBAL_AUTOMATON
global GLOBAL_PIHA
global GLOBAL_APPROX_PARAM

delta = GLOBAL_APPROX_PARAM.grow_size;


for i=1:length(dE)
   CI=[CE(i,:) ; CI];
   dI=[dE(i)+delta ; dI];
   CI=[-CE(i,:) ; CI];
   dI=[-( dE(i)-delta ) ; dI];
end
%changed by xiyan 03/09/2004. This change allow user to specify if the
%system needs to get the intersection of the new polyhedron and the sate.
%when specifying any element of the fourth argument to be zero, system will
%not get the intersection of the new polyhedron and the state.

if tmp(1)~=0&&tmp(2)~=0&&tmp(3)~=0
    state_region=GLOBAL_AUTOMATON{tmp(1)}.interior_region{tmp(2)}.state{tmp(3)}.polytope;

    [d,c,CI_state,dI_state]=linearcon_data(state_region);

    box=linearcon(d,c,[CI ; CI_state],[dI ; dI_state]);
else
    box=linearcon([],[],CI,dI);
end

box=clean_up(box);

return