function plot_mapping(mapping)

% Plot the given 2-D/3-D `mapping` set.
% 
% Syntax:
%   "plot_mapping(mapping)"
%
% Description:
%   Plot the "linearcon" object representing the polytopes in a `mapping`
%   set. A `mapping` set is the set that is computed by intersecting the
%   `flow pipe` segments with the faces of an invariant polytope. The input
%   variable "mapping" is an one dimensional cell array with the same number
%   of elements as the number of the invariant faces. "mapping{k}" containts
%   the mapping polytopes on the "k"-th face of the invariant.
%
% Note:
%   This routine only works for 2-D or 3-D mapping sets. For 2-D mapping
%   sets, the boundary between two polytopes will not be visible if the
%   polytopes being plot are lines.
%
% See Also:
%   piha,iauto_part,compute_mapping

for k = 1:length(mapping)
  for l = 1:length(mapping{k})
    plot(mapping{k}{l},[1 1 0])
  end
end
return
