function varargout = AboutCheckMate()

% Bring up the splash window for CheckMate. 
%
% Syntax:
%   "AboutCheckMate"
%
% Description:
%   Typing the function name at the MATLAB command prompt brings up the
%   splash window for CheckMate. The splash window provides the user with
%   the information about the current version of CheckMate and the link to
%   CheckMate's HTML based on-line help.
%
% See Also:
%   HelpCheckMate

% Raise the existing about GUI, if one can be found.
fig = findobj(0,'type','figure','tag','cm_about_gui');
if ~isempty(fig)
  delete(fig(2:end))
  figure(fig(1))
  if nargout > 0
    varargout{1} = fig(1);
  end
  return
end

% Otherwise load the about GUI from a figure file and initialize the
% callback functions for the buttons.

fig = openfig('cm_about_gui.fig');

msg1 = findobj(fig,'Tag','msg1');
set(msg1,'String','Hybrid System Verification Tool for MATLAB');
msg2 = findobj(fig,'Tag','msg2');
set(msg2,'String','Version 3.6 beta')
msg3 = findobj(fig,'Tag','msg3');
set(msg3,'String','September 23, 2003')

help_button = findobj(fig,'Tag','help_button');
gettingstarted = [which('gettingstarted.txt')];
set(help_button,'Callback',[' type(''' gettingstarted '''); close(gcbf)']);
ok_button = findobj(fig,'Tag','ok_button');
set(ok_button,'Callback','close(gcbf);');

align_figure(fig,'center','center')
set(fig,'Visible','on');

if nargout > 0
  varargout{1} = fig;
end

return