function fig = camera_control()

% CheckMate camera control function for manipulating plots
%
% Syntax:
%   "camera_control"
%
% Description:
%   "camera_control" opens a figure window containing controls for
%   manipulating CheckMate plots.
%
% See Also:
%   camera_callback

% This is the machine-generated representation of a Handle Graphics object
% and its children.  Note that handle values may change when these objects
% are re-created. This may cause problems with any callbacks written to
% depend on the value of the handle at the time the object was saved.
%
% To reopen this object, just type the name of the M-file at the MATLAB
% prompt. The M-file and its associated MAT-file must be on your path.

load camera_control

h0 = figure('Color',[1 0.9255 0.8576], ...
	'Colormap',mat0, ...
	'PointerShapeCData',mat1, ...
	'Position',[645 108 565 265], ...
	'Resize','off', ...
	'Tag','camera_control');
h1 = uicontrol('Parent',h0, ...
	'BackgroundColor',[0.1554 0.5610000000000001 0.2636], ...
	'ListboxTop',0, ...
	'Position',[410.8666666666666 194.3333333333333 139.2 56.7111111111111], ...
	'Style','frame', ...
	'Tag','Frame1');
h1 = uicontrol('Parent',h0, ...
	'FontUnits','pixels', ...
	'BackgroundColor',[0.1554 0.5610000000000001 0.2636], ...
	'FontSize',12, ...
	'FontWeight','bold', ...
	'ForegroundColor',[1 1 1], ...
	'ListboxTop',0, ...
	'Position',[422.4666666666666 209.7999999999999 73.46666666666665 25.77777777777777], ...
	'String','Figure', ...
	'Style','text', ...
	'Tag','StaticText1');
h1 = uicontrol('Parent',h0, ...
	'BackgroundColor',[1 1 1], ...
	'Callback','camera_callback', ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[507.3061666666666 204.9473333333333 31.3883111111111 35.48230555555554], ...
	'String','1', ...
	'Style','edit', ...
	'Tag','fig_edit');
h1 = uicontrol('Parent',h0, ...
	'BackgroundColor',[0.947 0.0814 0.1824], ...
	'ListboxTop',0, ...
	'Position',[16.01176944444444 9.188230555555553 539.0584444444444 170.5876666666666], ...
	'Style','frame', ...
	'Tag','Frame1');
h1 = uicontrol('Parent',h0, ...
	'FontUnits','pixels', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Callback','camera_callback', ...
	'FontSize',12, ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[299.8707777777777 32.3883111111111 241.5522777777777 34.11769444444444], ...
	'String','-78', ...
	'Style','edit', ...
	'Tag','el_edit');
h1 = uicontrol('Parent',h0, ...
	'FontUnits','pixels', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Callback','camera_callback', ...
	'FontSize',12, ...
	'HorizontalAlignment','right', ...
	'ListboxTop',0, ...
	'Position',[28.29415555555555 32.3883111111111 240.1876666666666 34.11769444444444], ...
	'String','164.1', ...
	'Style','edit', ...
	'Tag','az_edit');
h1 = uicontrol('Parent',h0, ...
	'FontUnits','pixels', ...
	'BackgroundColor',[0.947 0.0814 0.1824], ...
	'FontSize',12, ...
	'FontWeight','bold', ...
	'ForegroundColor',[1 1 1], ...
	'ListboxTop',0, ...
	'Position',[299.8707777777777 132.0116888888888 240.1876666666666 32.75292222222221], ...
	'String','Elevation (deg)', ...
	'Style','text', ...
	'Tag','StaticText1');
h1 = uicontrol('Parent',h0, ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Callback','camera_callback', ...
	'ListboxTop',0, ...
	'Max',180, ...
	'Min',-180, ...
	'Position',[28.29415555555555 82.88230555555555 240.1876666666666 32.75292222222221], ...
	'Style','slider', ...
	'Tag','az_slider', ...
	'Value',164.0999999999999);
h1 = uicontrol('Parent',h0, ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Callback','camera_callback', ...
	'ListboxTop',0, ...
	'Max',180, ...
	'Min',-180, ...
	'Position',[299.8707777777777 82.88230555555555 240.1876666666666 32.75292222222221], ...
	'Style','slider', ...
	'Tag','el_slider', ...
	'Value',-78);
h1 = uicontrol('Parent',h0, ...
	'FontUnits','pixels', ...
	'BackgroundColor',[0.947 0.0814 0.1824], ...
	'FontSize',12, ...
	'FontWeight','bold', ...
	'ForegroundColor',[1 1 1], ...
	'ListboxTop',0, ...
	'Position',[28.29415555555555 132.0116888888888 240.1876666666666 32.75292222222221], ...
	'String','Azimuth (deg)', ...
	'Style','text', ...
	'Tag','StaticText1');
h1 = uicontrol('Parent',h0, ...
	'FontUnits','pixels', ...
	'Callback','camera_callback', ...
	'FontSize',12, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[269.8477222222222 200.1719999999999 81.88230555555555 45.03522777777776], ...
	'String','Close', ...
	'Tag','close_button');
h1 = uicontrol('Parent',h0, ...
	'FontUnits','pixels', ...
	'Callback','camera_callback', ...
	'FontSize',12, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[149.7529222222222 200.1719999999999 81.88230555555555 45.03522777777776], ...
	'String','Reset', ...
	'Tag','reset_button');
h1 = uicontrol('Parent',h0, ...
	'FontUnits','pixels', ...
	'Callback','camera_callback', ...
	'FontSize',12, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[29.65876666666666 200.1719999999999 81.88230555555555 45.03522777777776], ...
	'String','Grid', ...
	'Tag','grid_button');
if nargout > 0, fig = h0; end
