function result = isempty(v)

% Determine if a vertices object is empty 
%
% Syntax:
%   "result = isempty(vtcs)"
%
% Description:
%   "isempty(vtcs)" returns "1" if "vtcs" is empty and "0" otherwise. 
%
% Examples:
%   Given a vertices object, "vtcs" representing a square in the x3 = 0
%   plane with corners at (x1,x2) pairs (2,1), (2,3), (4,3), and (4,1) 
%
%
%
%   "result = isempty(vtcs)"
%
%
%
%   returns 
%
%
%
%   "result = 0"
%
%
%
%   while 
%
%
%
%   "vtcs = vertices;"
%
%   "result = isempty(vtcs)"
%
%
%
%   returns 
%
%
%
%   "result = 1"
%
%
%
% See Also:
%   vertices

result = isempty(v.list);

