function l = length(v)

% Find the length of a vertices object 
%
% Syntax:
%   "l = length(vtcs)"
%
% Description:
%   "length(vtcs)" returns the number of points represented by "vtcs". 
%
% Examples:
%   Given a vertices object, "vtcs" representing a square in the x3 = 0
%   plane with corners at (x1,x2) pairs (2,1), (2,3), (4,3), and (4,1), 
%
%
%
%   "l = length(vtcs)"
%
%
%
%   returns 
%
%
%
%   "l = 4"
%
%
%
% See Also:
%   vertices

l = size(v.list,2);
